import { MAX, MIN, Tuple } from "../storage/types";
import { RemoveTuplePrefix, TuplePrefix } from "./typeHelpers";
export declare type ScanArgs<T extends Tuple, P extends TuplePrefix<T>> = PrefixScanArgs<T, P>;
export declare type PrefixScanArgs<T extends Tuple, P extends TuplePrefix<T>> = {
    prefix?: P;
    gt?: AllowMinMax<TuplePrefix<RemoveTuplePrefix<T, P>>>;
    gte?: AllowMinMax<TuplePrefix<RemoveTuplePrefix<T, P>>>;
    lt?: AllowMinMax<TuplePrefix<RemoveTuplePrefix<T, P>>>;
    lte?: AllowMinMax<TuplePrefix<RemoveTuplePrefix<T, P>>>;
    limit?: number;
    reverse?: boolean;
};
declare type AllowMinMax<T extends Tuple> = {
    [K in keyof T]: T[K] | typeof MIN | typeof MAX;
};
export declare type TxId = string;
export declare type Unsubscribe = () => void;
export {};
//# sourceMappingURL=../../src/database/types.d.ts.map